/****************************************************************************
**
** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the Qt Messaging Framework.
**
** $QT_BEGIN_LICENSE:LGPL$
** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the either Technology Preview License Agreement or the
** Beta Release License Agreement.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain
** additional rights. These rights are described in the Nokia Qt LGPL
** Exception version 1.0, included in the file LGPL_EXCEPTION.txt in this
** package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
** If you are unsure which license is appropriate for your use, please
** contact the sales department at qt-sales@nokia.com.
** $QT_END_LICENSE$
**
****************************************************************************/

#include "messageserver.h"
#include <QApplication>
#include <QDebug>
#include <qmailnamespace.h>

#if defined(HANDLE_SHUTDOWN_SIGNALS) && defined(Q_OS_UNIX)
#define SHUTDOWN_SIGNAL_HANDLING
#endif

#ifdef SHUTDOWN_SIGNAL_HANDLING
#include <signal.h>

static void shutdown(int n)
{
    qWarning() << "Received signal" << n << "- terminating.";
    QCoreApplication::exit();
}
#endif

int main(int argc, char** argv)
{

    if(QMail::fileLock("messageserver-instance.lock") == -1)
        qFatal("Could not get messageserver lock. Messageserver might already be running!");

    QApplication app(argc, argv);

    MessageServer server;

#ifdef SHUTDOWN_SIGNAL_HANDLING
    signal(SIGINT, shutdown);
    signal(SIGTERM, shutdown);
#endif

    int exitCode = app.exec();

    return exitCode;
}

